/*!
 * (c) 2019-2020 jackieli 西门互联
 * https://github.com/jackieli123723/ts-sort-array
 * http://issue.lilidong.cn
 * Released under the MIT License.
 */
(function (global, factory) {
   typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
   typeof define === 'function' && define.amd ? define(['exports'], factory) :
   (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.tsSortCounting = {}));
}(this, (function (exports) { 'use strict';

   function countingSortSync(arr, maxValue) {
       // 1.
       var i;
       var indexOfReturn = 0;
       var count = [];
       var max = maxValue || 9;
       // 2.
       for (i = 0; i <= max; i++) {
           count[i] = 0;
       }
       // 3.
       for (i = 0; i < arr.length; i++) {
           count[arr[i]]++;
       }
       // 4.
       for (i = 0; i <= max; i++) {
           while (count[i]-- > 0) {
               arr[indexOfReturn++] = i;
           }
       }
       return arr;
   }
   function countingSort(arr, callback) {
       var result = countingSortSync(arr);
       callback && typeof callback == 'function' && callback(result);
   }
   function countingSortAsync(arr) {
       var result = countingSortSync(arr);
       return Promise.resolve(result);
   }

   exports.countingSort = countingSort;
   exports.countingSortAsync = countingSortAsync;
   exports.countingSortSync = countingSortSync;

   Object.defineProperty(exports, '__esModule', { value: true });

})));
